package cz.cvut.fel.pr1.cars.model;

import java.util.Objects;

/**
 * The Engine class represents an engine of a car 
 * @author balikm1
 */
public class Engine {
    private final String type;
    
    //<editor-fold defaultstate="collapsed" desc="initialization">
    /**
     * Constructs a newly allocated Engine object that represents the engine of a car
     * @param type type of the engine
     */
    public Engine(String type) {
        this.type = type;
    }
    //</editor-fold>

    //<editor-fold defaultstate="collapsed" desc="properties">
    /**
     * Get type of the engine
     * @return type of the engine
     */
    public String getType() {
        return type;
    }
    //</editor-fold>

    //<editor-fold defaultstate="collapsed" desc="object overrides">
    @Override
    public int hashCode() {
        int hash = 7;
        hash = 37 * hash + Objects.hashCode(this.type);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Engine other = (Engine) obj;
        return Objects.equals(this.type, other.type);
    }

    @Override
    public String toString() {
        return String.format("%s engine", type);
    }
    //</editor-fold>
}
