package cz.cvut.fel.pr1.data;

import cz.cvut.fel.pr1.cars.model.Car;

/**
 * The CarListNode class represents a node used build a liked list of cars
 * @author balikm1
 */
public class CarListNode {
    private final Car car;
    private CarListNode next;
    
    //<editor-fold defaultstate="collapsed" desc="initialization">
    /**
     * Constructs a newly allocated CarListNode object that represents a node used build a liked list of cars.
     * @param car the single car instance
     * @param next reference to the next linked list node
     */
    public CarListNode(Car car, CarListNode next) {
        this.car = car;
        this.next = next;
    }
    //</editor-fold>

    //<editor-fold defaultstate="collapsed" desc="properties">
    /**
     * Get the car instance
     * @return the car instance
     */
    public Car getCar() {
        return car;
    }

    /**
     * Get the reference to the next linked list node
     * @return the reference to the next linked list node
     */
    public CarListNode getNext() {
        return next;
    }

    /**
     * Set the reference to the next linked list node
     * @param next the reference to the next linked list node
     */
    public void setNext(CarListNode next) {
        this.next = next;
    }
    //</editor-fold>
}
