package cz.cvut.fel.pr1.data.utils;

/**
 * Utility class providing methods to deal with arrays
 * @author balikm1
 */
public class ArrayUtil {
    // private constructor to avoid creating instances
    private ArrayUtil() { }
    
    //<editor-fold defaultstate="collapsed" desc="public methods">
    /**
     * Method sorts an array of "comparable" elements using the bubble sort algorithm.
     * The input array is sorted after the method is execured
     * @param array the array to sort
     * @see java.lang.Comparable
     */
    public static void sort(Comparable[] array) {
        for (int i=0; i<array.length; i++)
            for (int j=0; j<array.length-1; j++) {
                if (array[i].compareTo(array[j]) < 0)
                    swap(array, i, j);
            }
    }
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="helper methods">
    private static void swap(Comparable[] array, int first, int second) {
        Comparable temp = array[first];
        array[first] = array[second];
        array[second] = temp;
    }
    //</editor-fold>
}
